# API Documentation of Bash Range Expand Library

## range expand

### DEPRECATED:

```
DEPRECATED: bre_expand_ranges <prefix> <suffix> <reserved> <input-string> [..]
# This function is deprecated, use bre_expand instead.
#  <prefix> and <suffix> are strings without spaces
#  <reserved> is reserved for the name of the macro associative array
#             this will be implemented in a future version
#  <input-string> can be the following:
#    a macro: a string which is key in the associative array BRE_RANGE_MACROS
#             its value will be expanded in recursive fashion
#    a range (<number>-<number>): will be expanded to each member of range
#                                 prefix and suffix will be added to each
#    a number: prefix and suffix will be added
#    any other string (must not contain spaces): will be copied unmodified
# errors: 2
```

### bre_expand

```
bre_expand <ret-array-vn> <range-dict-vn> <prefix> <suffix> <range> [..]
# expand ranges found in range-dict and return it in ret-array
# range-dict keys are names of ranges (whitespace not allowed)
#   and their values can be:
#     a macro: any text string that matches a key of range-dict
#              its value will be expanded in recursive fashion
#     a range (<number>-<number>): will be expanded to each member of range
#                                  prefix and suffix will be added to each
#     a number: prefix and suffix will be added
#     any other string will be copied unmodified
# errors: 2, 3
```
